# /**************************************************/
# /* makefile.m4 - source for 'makefile'	    */
# /**************************************************/

# /**************************************************/
# /* You should not need to touch anything here     */
# /* unless you are adding a new platform. Change   */
# /* makefile instead.				    */
# /**************************************************/

# /* "$Id: makefile.m4,v 1.3 2002/12/21 19:51:53 bhepple Exp $" */

.SUFFIXES: .def .opn .dat

.dat.opn:
	LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/local/lib ./sm2c_temp $<
.dat.def:
	LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/local/lib ./sm2c_temp $<

# for the newer Gnu makes, export all variables. Wish they'd make up their minds.
export

LIBDIR=_LOCAL_/lib
BINDIR=_LOCAL_/bin
INCDIR=_LOCAL_/include
MANDIR=_LOCAL_/man/man1
XWINHOME=/usr/X11R6

# /* Some defaults - can be overridden below */
ifdef(`_MAXREC_',MXR=-DSM_MAXREC=_MAXREC_)

define(_REVISION_,_MAJOR_._MINOR_)

ifdef(`_DEBUG_',
DEBUG=-g -DSM_DEBUG=1
LDEBUG=-g
,
DEBUG=-O -s
LDEBUG=
)

ifdef(`_USE_GNU_CC_',CC=gcc)

CFLAGS=$(MXR) $(DEBUG) $(DEBUG_HEAP) $(CURSES) -I $(INCDIR) -D$(OSNAME)
LDFLAGS=$(LDEBUG) -L. -L $(LIBDIR)
EXTRA_SM2C_LIBS=
CURSESLIB=curses
CURSES=

# /* There's a space character here ... Unix likes it; TurboC hates it */
OUTPUT=-o $@

OBJ=.o
EXE=
LIBSUFFIX=.a

RM=rm -f
INSTALL=cp

INCS=smio.h smlib.h

ifdef(`_USE_XAW_',
XOBJS=smxaw$(OBJ)
XINCS=smxaw.h
XOTHER=scrmgr.xct
XLIBS=-L$(XWINHOME)/lib -lXaw3d -lXmu -lXt -lXext -lX11
SM_XDEF=-DSM_XAW=1
)

OTHERS=smdisp$(EXE) smedit$(EXE) smsort$(EXE) smgrep$(EXE) smfind$(EXE) pcurse$(EXE)
SCRIPTS=db2sm

ifelse(_OS_, SMSUNOS,
#/**************************************************/
#/*** SunOS under System V curses ******************/
#/**************************************************/

OSNAME=SM_SUNOS

default: all

ctool:
	cc $(DEBUG) ctool.c -o ctool -lsuntool -lsunwindow -lpixrect
xctool: xctool.c
	cc -O xctool.c -o xctool -I$(OPENWINHOME)/include -I$(INCDIR) -L$(OPENWINHOME)/lib -L$(LIBDIR) -lxview -lolgx -lX11
#/* Note: xctool used to bomb if loaded -O instead of -g */

OTHERS=xctool$(EXE) smdisp$(EXE) smedit$(EXE) smsort$(EXE) smgrep$(EXE) smfind$(EXE)
XWINHOME=$(OPENWINHOME)

ifdef(`USE_GNU_CC',
CFLAGS=$(DEBUG) $(CURSES) $(MXR) -nostdinc -O -I . -I- -I /usr/5include -I /usr/include -I$(INCDIR) -DSM_SUNOS $(SM_XDEF)
LIBDIR=/usr/5lib
LDFLAGS=$(LDEBUG) -L$(LIBDIR)
LIBS=-L. -L$(LIBDIR) -lsm -L /usr/5lib/ -l$(CURSESLIB)  /usr/5lib/libc.a $(XLIBS)

, #else /* Native compiler */

CC=/usr/5bin/cc

ifdef(`_USE_XVIEW_',
ifdef(`_USE_XAW_',
cant use both old chap!
)
XOBJS=smxview$(OBJ)
SM_XDEF=-DSM_XVIEW=1
XLIBS=-L$(OPENWINHOME)/lib -lxview -lolgx -lX11
smxview$(OBJ): smxview.c
	$(CC) -c $(CFLAGS) $(DEBUG) $(CURSES) -I$(OPENWINHOME)/include $(SM_XDEF) smxview.c
#endif /* XVIEW */
)

ifdef(`_SHARED_LIBS_',
LIBSUFFIX=.so._MAJOR_._MINOR_
CFLAGS=$(DEBUG) $(CURSES) -pic -I$(INCDIR) -DSM_SUNOS $(SM_XDEF)
LIBS=-lsm -l$(CURSESLIB) $(XLIBS)
, #else
CFLAGS=$(DEBUG) $(CURSES) -I$(INCDIR) -DSM_SUNOS $(SM_XDEF)
LIBS=libsm.a -L$(LIBDIR) -l$(CURSESLIB) $(XLIBS)
#endif /* SHARED_LIBS */
)

#endif /* !USE_GNU_CC */
)

#endif /* SM_SUNOS */
)

ifelse(_OS_, SMXENIX, this is not actually supported anymore ...

# /**************************************************/
# /*** SCO Xenix 386 2.3.3 **************************/
# /**************************************************/

OSNAME=SM_XENIX

LIBS=-L$(LIBDIR) -lsm -l$(CURSESLIB) -lmalloc -lx

#endif /* SM_XENIX */
)

ifelse(_OS_, SMSYSV,

# /**************************************************/
# /*** Generic System V - e.g. Linux ****************/
# /**************************************************/

OSNAME=SM_SYSV

ifdef(`_SHARED_LIBS_',
CFLAGS=-fPIC $(MXR) $(DEBUG) $(CURSES) -I $(INCDIR) -D$(OSNAME) $(SM_XDEF)
,
CFLAGS=$(MXR) $(DEBUG) $(CURSES) -I $(INCDIR) -D$(OSNAME) $(SM_XDEF)
)

LIBS=-lsm -l$(CURSESLIB) $(XLIBS)
CURSES=-DUSE_NCURSES=1
CURSESLIB=ncurses

ifdef(`_USE_XVIEW_',
ifdef(`_USE_XAW_',cant use both old chap!)

XOBJS=smxview$(OBJ)
SM_XDEF=-DSM_XVIEW=1
XLIBS=-L$(OPENWINHOME)/lib -lxview -lolgx -lX11
smxview$(OBJ): smxview.c
	$(CC) -c $(CFLAGS) $(DEBUG) $(CURSES) -I$(OPENWINHOME)/include $(SM_XDEF) smxview.c
#endif /* XVIEW */
)

#endif /* SM_SYSV */
)

ifelse(_OS_, SMTURBOC,

# /**************************************************/
# /*** MS-DOS compiled by Turbo-C 2.0 ***************/
# /**************************************************/

OSNAME=SM_TURBOC

OBJ=.obj
EXE=.exe
LIBSUFFIX=.lib
OTHERS=smedit$(EXE) smsort$(EXE) smgrep$(EXE) smfind$(EXE)
SCRIPTS=
CC=tcc
INSTALL=copy

ALLOCA=alloca.$(OBJ)
NDIROBJ=ndir.$(OBJ)
NDIRINC=ndir.h
PIPEOBJ=popen.$(OBJ)
GETOPTOBJ=getoptx.$(OBJ)
GETOPTINC=getopt.h
UTIMESOBJ=utimes.$(OBJ)
FIXNAME=fixname.$(OBJ)

# No space for TurboC:
OUTPUT=-o$@

# /* RM=del ... brain damaged rm - use MKS version or my own! */
# /* No space here ... */
ifdef(`_DEBUG_',
DEBUG=-v -y -N  # /* No optimise; add debugging */
, #else
DEBUG=-G -O -N- # /* Optimise for speed */
)

#/* -A to enable ANSI-C __STDC__ etc ... but turboc is too picky! */
#/* -g0: stop after x warnings (i.e. don't stop for warnings) */
CFLAGS=-ml -g0 $(DEBUG) $(CURSES) -I$(INCDIR) -DSM_TURBOC

LDFLAGS=-ml $(DEBUG) $(CURSES) -L$(LIBDIR)
LIBS=libsm.lib lcurses.lib
EXTRA_SM2C_LIBS=

#endif /* SM_TURBOC */
)

ifelse(_OS_, SMSGI,

# /**************************************************/
# /*** Silicon Graphics under 4Sight ****************/
# /**************************************************/

Not working ...???

OSNAME=SM_SGI

ifdef(`_USE_GNU_CC_',,CC=cc)

LIBS=-lsm -l$(CURSESLIB) 

#endif /* SM_SGI */
)

# /**************************************************/
# /* End of configurable variables 		  */
# /**************************************************/

MYLIB_OBJS=	\
	fname$(OBJ) \
	regex$(OBJ) \
	re_fail$(OBJ) \
	fqn$(OBJ) \
	field$(OBJ) \
	addcomma$(OBJ) \
	undo_esc$(OBJ) \
	glob$(OBJ) \
	backup$(OBJ) \
	pathopen$(OBJ) \
	string$(OBJ) \
	array$(OBJ) \
	$(ALLOCA) \
	$(STRSTROBJ) \
	$(NDIROBJ) \
	$(PIPEOBJ) \
	$(GETOPTOBJ) \
	$(UTIMESOBJ) \
	$(FIXNAME)

default: programs

ifdef(`_USE_XAW_',
smxaw$(OBJ): smxaw.c
	$(CC) -c $(CFLAGS) $(DEBUG) -I$(XWINHOME)/include $(SM_XDEF) smxaw.c
)

SMLIBS=smlib$(OBJ) \
	smread$(OBJ) \
	smdb$(OBJ) \
	smio$(OBJ) \
	smwrite$(OBJ) \
	smfield$(OBJ) \
	smscreen$(OBJ) \
	smutil$(OBJ) \
	smgetfl$(OBJ) \
	smwhere$(OBJ) \
	smbuilt$(OBJ) \
	$(XOBJS) \
	$(MYLIB_OBJS)

SMLIB=libsm$(LIBSUFFIX)
ifelse(_OS_, SMTURBOC,
$(SMLIB): $(SMLIBS)
	-$(RM) $@ # /* this may need to be done manually because of MS-DOGs limit of 120 characters per command line!!
	for %%i in ($?) do echo "+%%i & > smlib.tlb */
	tlib $@ @smlib.tlb

,_OS_, SMSUNOS,
ifdef(`_SHARED_LIBS_',
$(SMLIB): $(SMLIBS)
	/usr/bin/ld -o $@ -assert pure-text $(SMLIBS)
,
$(SMLIB): $(SMLIBS)
	ar rcv $@ $?
	ranlib $@
#endif /* SHARED_LIBS */
)

,_OS_, SMSYSV,
ifdef(`_SHARED_LIBS_',
SMLIB=libsm.so
SMLIB1=$(SMLIB)._MAJOR_
SMLIB2=$(SMLIB)._MAJOR_._MINOR_

$(SMLIB): $(SMLIBS)
	-$(RM) $(SMLIB) $(SMLIB1) $(SMLIB2)
	gcc ``-shared -Wl,-soname,$(SMLIB1)'' -o $(SMLIB2) $(SMLIBS)
	ln -s $(SMLIB2) $(SMLIB1)
	ln -s $(SMLIB2) $(SMLIB)
,
$(SMLIB): $(SMLIBS)
	ar rcv $@ $?
	ranlib $@
))

# /* Note that sm2c is needed in building the others and the library */
PROGS= \
	smcreate$(EXE) \
	smdata$(EXE) \
	smquick$(EXE) \
	sm2awk$(EXE) \
	smupdate$(EXE) \
	smproj$(EXE) \
	smclean$(EXE) \
	$(OTHERS)

ALLPROGS=\
	sm2c$(EXE) \
	$(PROGS) \
	$(OTHERS) \
	$(SCRIPTS)

OBJFILES= \
	smlib$(OBJ) \
	smread$(OBJ) \
	smwrite$(OBJ) \
	smfield$(OBJ) \
	smscreen$(OBJ) \
	smdb$(OBJ) \
	smutil$(OBJ) \
	smgetfl$(OBJ) \
	smwhere$(OBJ) \
	smio$(OBJ) \
	$(XOBJS) \
	smstubio$(OBJ) \
	sm2c$(OBJ) \
	smquick$(OBJ) \
	smupdate$(OBJ) \
	sm2awk$(OBJ) \
	smbuilt$(OBJ) \
	smclean$(OBJ) \
	smedit$(OBJ) \
	smsort$(OBJ) \
	smjoin$(OBJ) \
	smgrep$(OBJ) \
	smfind$(OBJ) \
	$(MYLIB_OBJS)

programs $(PROGS): $(SMLIB)

$(OBJFILES): smlib.h smio.h

ifdef(`_SHARED_LIBS_',
sm2c_temp$(EXE): sm2c$(OBJ) smstubio$(OBJ) smlib$(OBJ) smread$(OBJ) $(MYLIB_OBJS)
	$(CC) $(LDFLAGS) $(OUTPUT) sm2c$(OBJ) smstubio$(OBJ) smlib$(OBJ) smread$(OBJ) $(MYLIB_OBJS)

sm2c: sm2c_temp
	$(CC) $(LDFLAGS) -o sm2c sm2c$(OBJ) smstubio$(OBJ) $(EXTRA_SM2C_LIBS) -lsm -l$(CURSESLIB)
, #else - not SHARED LIBS
sm2c_temp sm2c$(EXE): sm2c$(OBJ) smstubio$(OBJ) smlib$(OBJ) smread$(OBJ) 
	$(CC) $(LDFLAGS) $(OUTPUT) sm2c$(OBJ) smstubio$(OBJ) smlib$(OBJ) smread$(OBJ) $(EXTRA_SM2C_LIBS)
	cp sm2c$(EXE) sm2c_temp$(EXE)
)

smlib$(OBJ): smlib.h smio.h

smbuilt.def: smbuilt.dat sm2c_temp$(EXE)
	LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/local/lib ./sm2c_temp smbuilt.dat

smbuilt$(OBJ): smlib.h smio.h smbuilt.dat smbuilt.def

smquick$(EXE): smquick$(OBJ) smwrite$(OBJ) smdb$(OBJ) smstubio$(OBJ) 
	$(CC) $(LDFLAGS) $(OUTPUT) smquick$(OBJ) smwrite$(OBJ) smdb$(OBJ) smstubio$(OBJ) $(LIBS)

smupdate$(EXE): smupdate$(OBJ) smstubio$(OBJ)
	$(CC) $(LDFLAGS) $(OUTPUT) smupdate$(OBJ) smstubio$(OBJ) $(LIBS)

smcreate.def: smcreate.dat sm2c_temp$(EXE)
	LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/local/lib ./sm2c_temp smcreate.dat

smcreate$(OBJ): smlib.h smio.h smcreate.dat smcreate.def

smcreate$(EXE): smcreate$(OBJ) smio.h smlib.h
	$(CC) $(LDFLAGS) $(OUTPUT) smcreate$(OBJ) $(LIBS)

smdata.def: smdata.dat sm2c_temp$(EXE)
	LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/local/lib ./sm2c_temp smdata.dat

smdata$(OBJ): smlib.h smio.h smdata.dat smdata.def

smdata$(EXE):  smdata$(OBJ) $(SMLIB)
	$(CC) $(LDFLAGS) $(OUTPUT) smdata$(OBJ) $(LIBS)

smedit.def: smedit.dat sm2c_temp$(EXE)
	LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/local/lib ./sm2c_temp smedit.dat

smedit$(OBJ): smlib.h smio.h smedit.dat smedit.def

smedit$(EXE):  smedit$(OBJ)
	$(CC) $(LDFLAGS) $(OUTPUT) smedit$(OBJ) $(LIBS)

smsort.def: smsort.dat sm2c_temp$(EXE)
	LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/local/lib ./sm2c_temp smsort.dat

smsort$(OBJ): smlib.h smio.h smsort.dat smsort.def

smsort$(EXE):  smsort$(OBJ)
	$(CC) $(LDFLAGS) $(OUTPUT) smsort$(OBJ) $(LIBS)

smjoin.def: smjoin.dat sm2c_temp$(EXE)
	LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/local/lib ./sm2c_temp smjoin.dat

smjoin$(OBJ): smlib.h smio.h smjoin.dat smjoin.def

smjoin$(EXE):  smjoin$(OBJ)
	$(CC) $(LDFLAGS) $(OUTPUT) smjoin$(OBJ) $(LIBS)

smgrep.def: smgrep.dat sm2c_temp$(EXE)
	LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/local/lib ./sm2c_temp smgrep.dat

smgrep$(OBJ): smlib.h smio.h smgrep.dat smgrep.def

smgrep$(EXE):  smgrep$(OBJ)
	$(CC) $(LDFLAGS) $(OUTPUT) smgrep$(OBJ) $(LIBS)

smfind.def: smfind.dat sm2c_temp$(EXE)
	LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/local/lib ./sm2c_temp smfind.dat

smfind$(OBJ): smlib.h smio.h smfind.dat smfind.def

smfind$(EXE):  smfind$(OBJ)
	$(CC) $(LDFLAGS) $(OUTPUT) smfind$(OBJ) $(LIBS)

sm2awk$(EXE): sm2awk$(OBJ) smstubio$(OBJ)
	$(CC) $(LDFLAGS) $(OUTPUT) sm2awk$(OBJ) smstubio$(OBJ) $(LIBS) 

smproj.def: smproj.dat sm2c_temp$(EXE)
	LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/local/lib ./sm2c_temp smproj.dat

smproj$(OBJ): smlib.h smio.h smproj.def

smproj$(EXE): smproj$(OBJ)
	$(CC) $(LDFLAGS) $(OUTPUT) smproj$(OBJ) $(LIBS)

smclean$(EXE): smclean$(OBJ) smstubio$(OBJ) smdb$(OBJ)
	$(CC) $(LDFLAGS) $(OUTPUT) smclean$(OBJ) smdb$(OBJ) smstubio$(OBJ) $(LIBS)

pcurse$(EXE): pcurse$(OBJ)
	$(CC) $(LDFLAGS) $(OUTPUT) pcurse$(OBJ) -lncurses

ifelse(_OS_, SMTURBOC,,
smdisp$(EXE): smdisp$(OBJ)
	$(CC) $(LDFLAGS) $(OUTPUT) smdisp$(OBJ) -l$(CURSESLIB)
)

all: lib $(ALLPROGS) man postscript_man

dos_manuals install_man manuals:
	(cd doc; $(MAKE) 'MANDIR=$(MANDIR)' 'INSTALL=$(INSTALL)' $@)

man:	
	(cd doc; $(MAKE) man)

postscript_man:
	(cd doc; make $@)

ifdef(`_SHARED_LIBS_',`
install: all
	mkdir -p $(BINDIR) $(LIBDIR)
	$(INSTALL) $(ALLPROGS) $(XOTHER) $(BINDIR)
	$(INSTALL) $(SMLIB2) $(LIBDIR)
	-(cd $(LIBDIR); $(RM) $(SMLIB1) $(SMLIB); ln -s $(SMLIB2) $(SMLIB1); ln -s $(SMLIB1) $(SMLIB))
	(cd doc; $(MAKE) install)',`

install: all
	mkdir -p $(BINDIR)
	$(INSTALL) $(ALLPROGS) scrmgr.xct $(BINDIR)
	ifdef(`_STRIP_BINS_', (cd $(BINDIR); strip $(PROGS)))
	(cd doc; $(MAKE) install)')

lib:	$(SMLIB)

install_bin: $(SMLIB)
	mkdir -p $(LIBDIR) $(INCDIR)
	$(INSTALL) $(SMLIB) $(LIBDIR)
	$(INSTALL) $(INCS) $(XINCS) $(INCDIR)

SRCFILES= \
ctool.c \
xctool.c \
scrmgr.xct \
sm2awk.c \
sm2c.c \
smclean.c \
smdata.c \
smcreate.c \
smedit.c \
smio.c \
smstubio.c \
smxview.c \
smxaw.c \
smlib.c \
smread.c \
smsort.c \
smjoin.c \
smgrep.c \
smfind.c \
smwrite.c \
smfield.c \
smscreen.c \
smutil.c \
smgetfl.c \
smwhere.c \
smproj.c \
smquick.c \
smupdate.c \
smdisp.c \
smdb.c \
smbuilt.c \
smio.h \
smlib.h \
smxaw.h \
smxview.h \
makefile \
makefile.cpp \
smlib.tlb \
pcurse.c \
smcreate.dat \
smdata.dat \
smbuilt.dat \
smsort.dat \
smjoin.dat \
smgrep.dat \
smfind.dat \
smedit.dat \
smproj.dat \
db2sm

OTHERFILES=BUGS README COPYRIGHT

ALLFILES=$(SRCFILES) $(OTHERFILES)

ifelse(_OS_, SMTURBOC,
arc:
	arc u sm.arc $(ALLFILES) doc
)

clean:
	-$(RM) *$(OBJ)
	-$(RM) *~ 
	-$(RM) core*
	-$(RM) junk* 
	-$(RM) *.def 
	-$(RM) *.opn 
	-$(RM) $(SMLIB) $(SMLIB1) $(SMLIB2)
	-$(RM) sm2c$(EXE) sm2c_temp$(EXE) $(PROGS) $(OTHERS)
	-$(RM) -r distrib
	-$(RM) makefile.use scrmgr.spec
	-(cd doc && $(MAKE) clean)

rcscheckin: $(ALLFILES)
	ci -l $?
	touch rcscheckin
	(cd doc; $(MAKE) $@)

distrib: all
	if [ ! -d distrib ] ; then mkdir distrib; fi
	(cd distrib; for DIR in bin doc doc/man1 dosman lib lib/scrmgr; \
	    do \
		if [ ! -d $$DIR ] ; then mkdir $$DIR; fi \
	    done)
	$(INSTALL) $(ALLPROGS) distrib/bin
	(cd distrib/bin; ln -f smedit smmore)
	$(INSTALL) terminfo.src distrib/lib/scrmgr
	(cd doc; $(MAKE))
	(cd doc; $(MAKE) manuals dosman)
	$(INSTALL) 'doc/man1/*' distrib/man/man1
	$(INSTALL) 'doc/dosman/*' distrib/dosman
	(cd distrib; tar cvf - bin doc lib|compress -c >scrmgr.tar.Z)
	@echo "distrib/scrmgr.tar.Z is ready"
	
ifelse(_OS_, SMTURBOC,,`
tar:
	make clean
	(cd ..; tar cvzf scrmgr-_REVISION_-_RELEASE_.tgz scrmgr-_REVISION_ )

# Assumes that ../scrmgr-_REVISION_ exists and has links to the
# appropriate files here. Probably needs to run as root.
rpm:
	make clean
	(cd ..;	tar cvzf /usr/src/redhat/SOURCES/scrmgr-_REVISION_-_RELEASE_.tgz scrmgr-_REVISION_ )
	make scrmgr.spec
	rpm -ba scrmgr.spec
	$(RM) -rf /usr/src/redhat/BUILD/scrmgr-_REVISION_
	$(RM) -rf /usr/src/redhat/SOURCES/scrmgr-_REVISION_
	echo "RPMs are"
	@echo /usr/src/redhat/SRPMS/scrmgr-_REVISION_*
	@echo /usr/src/redhat/RPMS/i386/scrmgr-_REVISION_*
')

install_rpm:
	(DEST=~/public_html/scrmgr/ ;\
	cp /usr/src/redhat/SRPMS/scrmgr-_REVISION_-_RELEASE_.src.rpm $$DEST ;\
	cp /usr/src/redhat/RPMS/i386/scrmgr-_REVISION_-_RELEASE_.i386.rpm $$DEST ;\
	cp /usr/src/redhat/SOURCES/scrmgr-_REVISION_-_RELEASE_.tgz $$DEST)

# DO NOT DELETE THIS LINE -- make depend depends on it.
